; +    ,4  
; PPM
; 1.0b free
;(C)   
;http://radioteh.nm.ru/

;=============================================
        LIST    p=16F84
       __CONFIG 03FF9H
;=============================================

IndF        equ        00h         ;     FSR
Timer0      equ        01h         ; TMR0
OptionR     equ        01h         ; Option (RP0=1)
PC          equ        02h         ;  
Status      equ        03h         ; Status
FSR         equ        04h         ;   
PortA       equ        05h         ; Port A
TrisA       equ        05h         ; Tris A - RP0=1
PortB       equ        06h         ; Port B
TrisB       equ        06h         ; Tris B - RP0=1
EEData      equ        08h         ; EEPROM Data
EECon1      equ        08h         ; EECON1 - RP0=1
EEAdr       equ        09h         ; EEPROM Address
EECon2      equ        09h         ; EECON2 - RP0=1

;=============================================
;                                     
W           equ        0           ; 
F           equ        1           ; 
;
;=============================================
; Flag bits:
CF          equ        0           ; Carry
DC          equ        1           ; DC
ZF          equ        2           ; Zero
RP0         equ        5
;=============================================
Temp        equ        0Ch
Count       equ        0dh
CountH      equ        0eh
ldCount     equ        0fh
TiMZ        equ        10h

            ORG        0h

Start
            clrf       Count
            clrf       CountH 
            clrf       PortA       ; RA0..RA3 = 0
            bsf        Status,RP0
            movlw      b'00010000'
            movwf      TrisA       ; RA0-RA3 output RA4 input
            movlw      b'00000000'
            movwf      TrisB       ; RB output
            bcf        Status,RP0  ;
            movlw      b'00000000' ;
            movwf      PortB       ;B0-B7 =0
            movlw      b'00001111'
            movwf      PortA       ;B0-B3=1




Sinhro     
            call       DetectSI    ;!!!!

;********** 1-  **************

            call       ki          ;  

            movlw      08h         ;!!!!    
            movwf      TiMZ        ;

            btfsc      PortB,1     ;
            goto       s1          ;
            btfsc      PortB,0     ;
            goto       s1
            movlw      1h          ;     
            movwf      TiMZ        ;


s1          bcf        PortB,1     ;
            bcf        PortB,0     ;

            bsf        Status,RP0
            movlw      b'00010001'
            movwf      TrisA       ; RA0,RA4 input
            bcf        Status,RP0  ;


    ;  

detect1      
            btfss      PortA,0     ;  RC   1
            goto       GRB0        ;    R
            btfss      PortA,4     ;  KI   1
            goto       GRB1        ;    R
            goto       detect1

GRB0
            call       p1          ;   
            btfss      PortA,4     ; I=1    
            goto       K1_OK       ; KI=0    

            bsf        PortB,0     ;     R
            
            btfsc      PortA,4     ;  
            goto       $-1         ;RA4.
            goto       EndK1       ;  1 

GRB1
            call       p1          ;   
            btfss      PortA,0     ; SI=1
            goto       K1_OK       ; SI=0    
            bsf        PortB,1     ;     R
            goto       EndK1 

K1_OK
            bcf        PortB,0     ; 
            bcf        PortB,1

EndK1

            bsf        Status,RP0  ;
            movlw      b'00010000' ;
            movwf      TrisA       ; RA output
            bcf        Status,RP0  ; RA0..RA3=1
            movlw      b'00001111'
            movwf      PortA



;********** 2-  **************

            call       ki          ;  
            movlw      06h         ;!!!!    
            movwf      TiMZ        ;
            btfsc      PortB,2     ;
            goto       s2          ;
            btfsc      PortB,3     ;
            goto       s2
            movlw      1h          ;     
            movwf      TiMZ        ;


s2          bcf        PortB,2     ; 
            bcf        PortB,3
            bsf        Status,RP0
            movlw      b'00010010'
            movwf      TrisA       ; RA1,RA4 input
            bcf        Status,RP0  ;

    ;  

detect2      
            btfss      PortA,1     ;  RC   1
            goto       GRB20        ;    R
            btfss      PortA,4     ;  KI   1
            goto       GRB21        ;    R
            goto       detect2

GRB20
            call       p1          ;   
            btfss      PortA,4     ; I=1    
            goto       K2_OK       ; KI=0    
       
            bsf        PortB,2     ;     R

            btfsc      PortA,4     ;  
            goto       $-1         ;RA4.
            goto       EndK2       ;  2 

GRB21
            call       p1          ;   
            btfss      PortA,1     ; SI=1
            goto       K2_OK       ; SI=0    
            
            bsf        PortB,3     ;     R
            goto       EndK2 

K2_OK
            bcf        PortB,2     ; 
            bcf        PortB,3

EndK2

            bsf        Status,RP0  ;
            movlw      b'00010000' ;
            movwf      TrisA       ; RA output
            bcf        Status,RP0  ; RA0..RA3=1
            movlw      b'00001111'
            movwf      PortA


;********** 3-  **************

            call       ki          ;  
            movlw      06h         ;!!!!    
            movwf      TiMZ        ;
            btfsc      PortB,4     ;
            goto       s3          ;
            btfsc      PortB,5     ;
            goto       s3
            movlw      1h          ;     
            movwf      TiMZ        ;

s3          bcf        PortB,4     ; 
            bcf        PortB,5
            bsf        Status,RP0
            movlw      b'00010100'
            movwf      TrisA       ; RA3,RA4 input
            bcf        Status,RP0  ;

    ;  

detect3      
            btfss      PortA,2     ;  RC   1
            goto       GRB30        ;    R
            btfss      PortA,4     ;  KI   1
            goto       GRB31        ;    R
            goto       detect3

GRB30
            call       p1          ;   
            btfss      PortA,4     ; I=1    
            goto       K3_OK       ; KI=0    
            bsf        PortB,4     ;     R
            btfsc      PortA,4     ;  
            goto       $-1         ;RA4.
            goto       EndK3       ;  3 

GRB31
            call       p1          ;   
            btfss      PortA,2     ; SI=1
            goto       K3_OK       ; SI=0                
            bsf        PortB,5     ;     R
            goto       EndK3       ;  3 

K3_OK
            bcf        PortB,4     ; 
            bcf        PortB,5

EndK3

            bsf        Status,RP0  ;
            movlw      b'00010000' ;
            movwf      TrisA       ; RA output
            bcf        Status,RP0  ; RA0..RA3=1
            movlw      b'00001111'
            movwf      PortA

;********** 4-  **************

            call       ki          ;  
            movlw      06h         ;!!!!    
            movwf      TiMZ        ;
            btfsc      PortB,6     ;
            goto       s4          ;
            btfsc      PortB,7     ;
            goto       s4
            movlw      1h          ;     
            movwf      TiMZ        ;


s4          bcf        PortB,6     ; 
            bcf        PortB,7
            bsf        Status,RP0
            movlw      b'00011000'
            movwf      TrisA       ; RA3,RA4 input
            bcf        Status,RP0  ;

    ;  

detect4      
            btfss      PortA,3     ;  RC   1
            goto       GRB40        ;    R
            btfss      PortA,4     ;  KI   1
            goto       GRB41        ;    R
            goto       detect4

GRB40
            call       p1          ;   
            btfss      PortA,4     ; I=1    
            goto       K4_OK       ; KI=0                
            bsf        PortB,6     ;     R
            btfsc      PortA,4     ;  
            goto       $-1         ;RA4.
            goto       EndK4       ;  3 

GRB41
            call       p1          ;   
            btfss      PortA,2     ; SI=1
            goto       K4_OK       ; SI=0    
            bsf        PortB,7     ;     R
            goto       EndK4 

K4_OK
            bcf        PortB,6     ; 
            bcf        PortB,7

EndK4

            bsf        Status,RP0  ;
            movlw      b'00010000' ;
            movwf      TrisA       ; RA output
            bcf        Status,RP0  ; RA0..RA3=1
            movlw      b'00001111'
            movwf      PortA





            goto       Sinhro
;********************************************
;*                               *
;********************************************
;-------------------------------------------------
;      
;-------------------------------------------------   
p1
            movf       TiMZ,W   
            movwf      Temp
Pause
            decfsz     Temp,F
            goto       Pause
            return

;-------------------------------------------------
; 
;------------------------------------------------
DetectSI

            clrf       Count
            clrf       CountH 
            btfss      PortA,4 ; 1
            goto       $-1
            ;  
ChkSinhro

            incf       Count,F
            btfsc      Status,ZF 
            incf       CountH,F
            btfsc      PortA,4
            goto       ChkSinhro
            
            ;  PortA,4   1  0
            movf       CountH,W   ; W-02
            sublw      02h        ; CountH>2h 
            btfsc      Status,CF  ; 
            goto       DetectSI   ; ,  
            return                ; 
;-------------------------------------------------
;  
;------------------------------------------------
ki          
            btfss      PortA,4
            goto       ki
            movlw      0ah   ;
            movwf      Temp  ;
            call       Pause ;     
            return

            end
